## s390-tools 2.31.0

=== Makefile ===
# Include common definitions
include common.mak

#
# BASELIBS: Libraries that have no dependency to other libraries in s390-tools
# LIBS: Libraries that can have a dependency to base libraries
# TOOLS: Tools that can have a dependency to base libraries or libraries
#
ifeq ($(HOST_ARCH),s390x)
BASELIB_DIRS = libutil libseckey
LIB_DIRS = libvtoc libzds libdasd libccw libvmcp libekmfweb \
	   libkmipclient libcpumf libap libpv
TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
	   vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl \
	   genprotimg lsstp hsci hsavmcore chreipl-fcp-mpath ap_tools pvattest \
	   rust
else
BASELIB_DIRS =
LIB_DIRS = libpv
TOOL_DIRS = genprotimg pvattest rust
endif

SUB_DIRS = $(BASELIB_DIRS) $(LIB_DIRS) $(TOOL_DIRS)

all: $(TOOL_DIRS)
clean: $(TOOL_DIRS)
install: $(TOOL_DIRS)

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

#
# We have to build the base libraries before the other libraries are built,
# and then build the other libraries before the tools are built. Otherwise the
# other libraries and tools would trigger parallel "make -C" builds for the
# base libraries and the other libraries in case of "make -j".
#
# MAKECMDGOALS contains the list of goals, e.g. "clean all". We use
# "foreach" to generate a ";" separated list of "make -C <target>".
# For example the the expansion for "make clean all" is:
#
# $(MAKE) -C $@ [..] clean ;  $(MAKE) -C $@ [...] all ;
#
# This ensures that the commandline targets are serialized and also "make -j"
# works as expected, e.g. "make clean all -j 20".
#

$(TOOL_DIRS): $(LIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(TOOL_DIRS)

$(LIB_DIRS): $(BASELIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(LIB_DIRS)

$(BASELIB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(BASELIB_DIRS)

=== cpacfstats/Makefile ===
include ../common.mak

ifeq (${HAVE_LIBUDEV},0)

all:
	$(SKIP) HAVE_LIBUDEV=0

install:
	$(SKIP) HAVE_LIBUDEV=0

else

check_dep:
	$(call check_dep, \
		"cpacfstatsd", \
		"libudev.h", \
		"systemd-devel", \
		"HAVE_LIBUDEV=0")

ALL_CPPFLAGS += -DVERSION=$(VERSION)

all:		check_dep cpacfstats cpacfstatsd

cpacfstatsd:	cpacfstatsd.o stats_sock.o perf_crypto.o
		$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -ludev -lpthread -o $@

cpacfstats:	cpacfstats.o stats_sock.o
		$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

install: 	all
		$(INSTALL) -m 755 cpacfstatsd   $(DESTDIR)$(USRSBINDIR)
		$(INSTALL) -m 755 cpacfstats    $(DESTDIR)$(USRBINDIR)
		$(INSTALL) -m 644 cpacfstatsd.8 $(DESTDIR)$(MANDIR)/man8
		$(INSTALL) -m 644 cpacfstats.1  $(DESTDIR)$(MANDIR)/man1

endif

clean:
		rm -f *.o *~ cpacfstatsd cpacfstats

.PHONY: all clean install check_dep

=== genprotimg/Makefile ===
# Common definitions
include ../common.mak

.DEFAULT_GOAL := all

PKGDATADIR := "$(DESTDIR)$(TOOLS_DATADIR)/genprotimg"
TESTS :=
SUBDIRS := boot src man
RECURSIVE_TARGETS := all-recursive install-recursive clean-recursive

all: all-recursive

install: install-recursive
	$(INSTALL) -d -m 755 "$(PKGDATADIR)"
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 samples/check_hostkeydoc "$(PKGDATADIR)"

clean: clean-recursive

$(RECURSIVE_TARGETS):
	@target=`echo $@ |sed s/-recursive//`; \
		for d in $(SUBDIRS); do \
			$(MAKE) -C $$d $$target || exit 1; \
		done

.PHONY: all install clean $(RECURSIVE_TARGETS)

=== libdasd/Makefile ===
include ../common.mak

lib = libdasd.a

all: $(lib)

objects = dasd_sys.o dasd_ioctl.o

$(lib): $(objects)

install: all

clean:
	rm -f *.o $(lib)

=== libpv/Makefile ===
# Common definitions
include ../common.mak

.DEFAULT_GOAL := all

LIB := libpv.a

GLIB2_CFLAGS := $(shell $(PKG_CONFIG) --silence-errors --cflags glib-2.0)
GLIB2_LIBS := $(shell $(PKG_CONFIG) --silence-errors --libs glib-2.0)
LIBCRYPTO_CFLAGS := $(shell $(PKG_CONFIG) --silence-errors --cflags libcrypto)
LIBCRYPTO_LIBS := $(shell $(PKG_CONFIG) --silence-errors --libs libcrypto)
LIBCURL_CFLAGS := $(shell $(PKG_CONFIG) --silence-errors --cflags libcurl)
LIBCURL_LIBS := $(shell $(PKG_CONFIG) --silence-errors --libs libcurl)
LDLIBS += $(GLIB2_LIBS) $(LIBCRYPTO_LIBS) $(LIBCURL_LIBS)

WARNINGS := -Wall -Wextra -Wshadow \
	    -Wcast-align -Wwrite-strings -Wmissing-prototypes \
	    -Wmissing-declarations -Wredundant-decls -Wnested-externs \
	    -Wno-long-long -Wuninitialized -Wconversion -Wstrict-prototypes \
	    -Wpointer-arith -Wno-error=inline \
	    -Wno-unused-function -Wno-unused-parameter -Wno-unused-variable \
	    $(NULL)

ALL_CFLAGS += -DOPENSSL_API_COMPAT=0x10101000L \
	      $(GLIB2_CFLAGS) \
	      $(LIBCRYPTO_CFLAGS) \
	      $(LIBCURL_CFLAGS) \
	      $(WARNINGS) \
	      $(NULL)

BUILD_TARGETS := skip-$(LIB)
ifneq (${HAVE_OPENSSL},0)
ifneq (${HAVE_GLIB2},0)
ifneq (${HAVE_LIBCURL},0)
BUILD_TARGETS := $(LIB)
endif
endif
endif

sources := $(wildcard *.c)
objects := $(patsubst %.c,%.o,$(sources))

all: $(BUILD_TARGETS)

$(LIB): $(objects)
$(LIB): ALL_CFLAGS += -fPIC

$(objects): .check-dep-$(LIB)

install: all

clean:
	rm -f -- $(objects)
	rm -f -- $(LIB)
	rm -f -- .check-dep-$(LIB) .detect-openssl.dep.c

skip-$(LIB):
		echo "  SKIP    $(LIB) due to unresolved dependencies"

.PHONY: all install clean skip-$(LIB) install-$(LIB)


.detect-openssl.dep.c:
	echo "#include <openssl/evp.h>" > $@
	echo "#if OPENSSL_VERSION_NUMBER < 0x10101000L" >> $@
	echo "  #error openssl version 1.1.1 is required" >> $@
	echo "#endif" >> $@
	echo "static void __attribute__((unused)) test(void) {" >> $@
	echo "    EVP_MD_CTX *ctx = EVP_MD_CTX_new();" >> $@
	echo "    EVP_MD_CTX_free(ctx);" >> $@
	echo "}" >> $@

.check-dep-$(LIB): .detect-openssl.dep.c
	$(call check_dep, \
		"$(LIB)", \
		"glib.h", \
		"glib2-devel / libglib2.0-dev", \
		"HAVE_GLIB2=0")
	$(call check_dep, \
		"$(LIB)", \
		$^, \
		"openssl-devel / libssl-dev version >= 1.1.1", \
		"HAVE_OPENSSL=0", \
		"-I.")
	$(call check_dep, \
		"$(LIB)", \
		"curl/curl.h", \
		"libcurl-devel", \
		"HAVE_LIBCURL=0")
	touch $@

=== osasnmpd/Makefile ===
include ../common.mak
NET_SNMP_CONFIG = net-snmp-config
LDLIBS = `$(NET_SNMP_CONFIG) --agent-libs`
# On some Linux systems `net-snmp-config --agent-libs` introduces -pie,
# therefore add -fPIC to prevent link failures.
ALL_CFLAGS += -fPIC
ALL_CFLAGS += `$(NET_SNMP_CONFIG) --cflags`

OBJS = ibmOSAMib.o ibmOSAMibUtil.o osasnmpd.o

ifeq (${HAVE_SNMP},0)

all:
	$(SKIP) HAVE_SNMP=0

install:
	$(SKIP) HAVE_SNMP=0

else

check_dep:
	$(call check_dep, \
		"osasnmpd", \
		"net-snmp/net-snmp-config.h", \
		"net-snmp-devel or libsnmp-dev", \
		"HAVE_SNMP=0")

all: check_dep osasnmpd

osasnmpd: $(OBJS)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRSBINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 osasnmpd \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 osasnmpd.8 \
		$(DESTDIR)$(MANDIR)/man8

endif

clean:
	rm -f $(OBJS) osasnmpd core

.PHONY: all install clean

=== zdsfs/Makefile ===
include ../common.mak

libs =	$(rootdir)/libzds/libzds.a \
	$(rootdir)/libvtoc/libvtoc.a \
	$(rootdir)/libdasd/libdasd.a \
	$(rootdir)/libutil/libutil.a

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0


else

ifeq (${HAVE_CURL},0)

all:
	$(SKIP) HAVE_CURL=0

install:
	$(SKIP) HAVE_CURL=0

else

check_dep:
	$(call check_dep, \
		"zdsfs", \
		"fuse.h", \
		"fuse3-devel or libfuse3-dev", \
		"HAVE_FUSE=0", \
		"-DFUSE_USE_VERSION=30")
	$(call check_dep, \
		"zdsfs", \
		"curl/curl.h", \
		"curl-devel or libcurl-dev", \
		"HAVE_CURL=0")

FUSE_CFLAGS = $(shell $(PKG_CONFIG) --silence-errors --cflags fuse3)
FUSE_LDLIBS = $(shell $(PKG_CONFIG) --silence-errors --libs fuse3)
CURL_CFLAGS = $(shell $(PKG_CONFIG) --silence-errors --cflags libcurl)
CURL_LDLIBS = $(shell $(PKG_CONFIG) --silence-errors --libs libcurl)
ALL_CPPFLAGS += -DSYSFS
ALL_CFLAGS += -DHAVE_SETXATTR -pthread $(FUSE_CFLAGS) $(CURL_CFLAGS)
LDLIBS += $(FUSE_LDLIBS) $(CURL_LDLIBS) -lpthread -lrt -lm

all: check_dep zdsfs

zdsfs: zdsfs.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR) $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zdsfs $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 zdsfs.1 \
		$(DESTDIR)$(MANDIR)/man1

endif

endif

clean:
	rm -f *.o *~ zdsfs core

.PHONY: all install clean

=== zdump/Makefile ===
include ../common.mak

ALL_CFLAGS += -Wno-address-of-packed-member

#
# HAVE_FUSE: Allow to build zgetdump without mount support
#
ifeq (${HAVE_FUSE},0)

.check_dep_fuse:
	touch $@
else

.check_dep_fuse:
	$(call check_dep, \
		"zgetdump mount support", \
		"fuse.h", \
		"fuse3-devel or libfuse3-dev", \
		"HAVE_FUSE=0", \
		"-DFUSE_USE_VERSION=30")
	touch $@
endif

.detect_openssl.dep.c:
	echo "#include <openssl/evp.h>" > $@
	echo "#if OPENSSL_VERSION_NUMBER < 0x10100000L" >> $@
	echo "  #error At least OpenSSL version 1.1.0 is required" >> $@
	echo "#endif" >> $@
	echo "static void __attribute__((unused)) test(void) {" >> $@
	echo "    EVP_MD_CTX *ctx = EVP_MD_CTX_new();" >> $@
	echo "    EVP_MD_CTX_free(ctx);" >> $@
	echo "}" >> $@

.check_dep_zgetdump: .detect_openssl.dep.c .check_dep_fuse
	$(call check_dep, \
		"zgetdump", \
		"zlib.h", \
		"zlib-devel or libz-dev", \
		"HAVE_ZLIB=0")
	$(call check_dep, \
		"zgetdump", \
		"glib.h", \
		"glib2-devel / libglib2.0-dev", \
		"HAVE_GLIB2=0")
	$(call check_dep, \
		"zgetdump", \
		$<, \
		"openssl-devel / libssl-dev version >= 1.1.0", \
		"HAVE_OPENSSL=0", \
		"-I.")
	touch $@

#
# Allow skip of zgetdump build, when no zlib-devel, openssl-devel, glib2-devel is available
#
BUILD_TARGETS :=skip-zgetdump
INSTALL_TARGETS := skip-zgetdump
ifneq (${HAVE_ZLIB},0)
ifneq (${HAVE_OPENSSL},0)
ifneq (${HAVE_GLIB2},0)
BUILD_TARGETS := zgetdump
INSTALL_TARGETS := install-zgetdump
endif
endif
endif

OBJECTS = zgetdump.o opts.o zg.o zg_error.o zg_print.o \
	  dfi.o dfi_mem_chunk.o dfi_vmcoreinfo.o \
	  dfi_lkcd.o dfi_elf.o dfi_elf_common.o dfi_pv_elf.o \
	  dfi_s390.o dfi_s390_ext.o\
	  dfi_s390mv.o dfi_s390mv_ext.o \
	  dfi_s390tape.o dfi_kdump.o \
	  dfi_devmem.o dfo.o dfo_mem_chunk.o \
	  dfo_elf.o dfo_s390.o \
	  df_elf.o df_s390.o \
	  dt.o dt_s390sv.o dt_s390sv_ext.o \
	  dt_s390mv.o dt_s390mv_ext.o \
	  dt_scsi.o output.o \
	  ngdump.o dt_ngdump.o dfi_ngdump.o dfi_vmdump.o \
	  pv_utils.o

GLIB2_CFLAGS := $(shell $(PKG_CONFIG) --silence-errors --cflags glib-2.0)
GLIB2_LIBS := $(shell $(PKG_CONFIG) --silence-errors --libs glib-2.0)
LIBCRYPTO_CFLAGS := $(shell $(PKG_CONFIG) --silence-errors --cflags libcrypto)
LIBCRYPTO_LIBS := $(shell $(PKG_CONFIG) --silence-errors --libs libcrypto)

LIBPV = $(rootdir)/libpv/libpv.a
LIBPV_CFLAGS := -DOPENSSL_API_COMPAT=0x10100000L \
	$(GLIB2_CFLAGS) \
	$(LIBCRYPTO_CFLAGS) \
	$(NULL)
LIBPV_LIBS := $(GLIB2_LIBS) $(LIBCRYPTO_LIBS)

ifeq ("$(HAVE_FUSE)","0")
FUSE_CFLAGS = -DHAVE_FUSE=0 -D_FILE_OFFSET_BITS=64
FUSE_LDLIBS =
else
FUSE_CFLAGS = -DHAVE_FUSE=1 $(shell $(PKG_CONFIG) --silence-errors --cflags fuse3)
FUSE_LDLIBS = $(shell $(PKG_CONFIG) --silence-errors --libs fuse3)
endif
LDLIBS += -lz $(FUSE_LDLIBS) $(LIBPV_LIBS)
ALL_CFLAGS += $(FUSE_CFLAGS) $(LIBPV_CFLAGS)

ifneq ("$(HAVE_FUSE)","0")
OBJECTS += zfuse.o
endif

libs = $(rootdir)/libutil/libutil.a $(LIBPV)

all: $(BUILD_TARGETS)

$(OBJECTS): .check_dep_zgetdump

zgetdump: $(OBJECTS) $(libs)

skip-zgetdump:
	echo "  SKIP    zgetdump due to unresolved dependencies"

install-zgetdump: zgetdump
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man8 $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 755 zgetdump $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 644 zgetdump.8 $(DESTDIR)$(MANDIR)/man8

install: $(INSTALL_TARGETS)

clean:
	rm -f -- *.o *~ zgetdump core.* .detect_openssl.dep.c .check_dep_zgetdump .check_dep_fuse

.PHONY: all install clean skip-zgetdump install-zgetdump

=== zfcpdump/Makefile ===
include ../common.mak

CPIOINIT  = $(call echocmd,"  CPIOINI     ",/$@)./cpioinit
INSTALL_SCRIPTS = 10-zfcpdump.install

ALL_CFLAGS += -fno-sanitize=all
ALL_LDFLAGS += -fno-sanitize=all

ifeq (${HAVE_LIBC_STATIC},0)

all:
	$(SKIP) HAVE_LIBC_STATIC=0

install:
	$(SKIP) HAVE_LIBC_STATIC=0

else

check_dep:
	$(call check_dep, \
		"zfcpdump", \
		"stdio.h", \
		"glibc-static or libc-dev", \
		"HAVE_LIBC_STATIC=0", \
		"-static")

all: check_dep $(ZFCPDUMP_INITRD) scripts

cpioinit: cpioinit.c
	$(CC_FOR_BUILD) $(CFLAGS_FOR_BUILD) -o $@ $^

zfcpdump_part: zfcpdump.o zfcpdump_part.o
	$(LINK) $(ALL_LDFLAGS) $^ -static -o $@
	$(STRIP) -s $@

$(ZFCPDUMP_INITRD): cpioinit zfcpdump_part
	$(CPIOINIT) zfcpdump_part > $@.tmp
	$(GZIP) -f $@.tmp
	$(MV) $@.tmp.gz $(ZFCPDUMP_INITRD)

scripts: $(INSTALL_SCRIPTS)
	chmod +x $(INSTALL_SCRIPTS)

install: all
	$(INSTALL) -m 611 $(ZFCPDUMP_INITRD) $(DESTDIR)$(ZFCPDUMP_DIR)

%: %.in
	zfcpdump_image=$(ZFCPDUMP_DIR)/$(ZFCPDUMP_IMAGE);	\
	$(SED)	-e "s#@zfcpdump_image@#$$zfcpdump_image#g"	\
		-e "s#@flavor@#$(ZFCPDUMP_FLAVOR)#g"		\
	< $< > $@
endif

clean:
	rm -f *.o *.gz *.tmp *~ zfcpdump_part cpioinit $(ZFCPDUMP_INITRD) \
		$(INSTALL_SCRIPTS)

.PHONY: all clean install check_dep scripts

=== dump2tar/man/Makefile ===
# Common definitions
include ../../common.mak

all:

install:
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -m 644 -c dump2tar.1 $(DESTDIR)$(MANDIR)/man1

clean:

.PHONY: all clean

=== genprotimg/man/Makefile ===
# Common definitions
include ../../common.mak

all:

install:
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -m 644 -c genprotimg.1 $(DESTDIR)$(MANDIR)/man1

clean:

.PHONY: all install clean

=== genprotimg/src/Makefile ===
# Common definitions
include ../../common.mak

bin_PROGRAM = genprotimg

PKGDATADIR ?= "$(DESTDIR)$(TOOLS_DATADIR)/genprotimg"
SRC_DIR := $(dir $(realpath $(firstword $(MAKEFILE_LIST))))
TOP_SRCDIR := $(SRC_DIR)/../
ROOT_DIR = $(TOP_SRC_DIR)/../../
ZIPL_DIR = $(ROOT_DIR)/zipl
LOADER_DIR = $(TOP_SRCDIR)/boot

INCLUDE_PATHS = "$(SRC_DIR)" "$(TOP_SRCDIR)" "$(ROOTDIR)/include"
INCLUDE_PARMS = $(addprefix -I,$(INCLUDE_PATHS))

WARNINGS := -Wall -Wextra -Wshadow \
	-Wcast-align -Wwrite-strings -Wmissing-prototypes \
	-Wmissing-declarations -Wredundant-decls -Wnested-externs \
	-Wno-long-long -Wuninitialized -Wconversion -Wstrict-prototypes \
	-Wpointer-arith -Wno-error=inline \
	$(NULL)

$(bin_PROGRAM)_SRCS := $(bin_PROGRAM).c pv/pv_stage3.c pv/pv_image.c \
	pv/pv_comp.c pv/pv_hdr.c pv/pv_ipib.c utils/crypto.c utils/file_utils.c \
	pv/pv_args.c utils/buffer.c pv/pv_comps.c pv/pv_error.c \
	pv/pv_opt_item.c utils/curl.c \
	$(NULL)
$(bin_PROGRAM)_OBJS := $($(bin_PROGRAM)_SRCS:.c=.o)

ALL_CFLAGS += -DPKGDATADIR=$(PKGDATADIR) \
	$(GLIB2_CFLAGS) $(LIBCRYPTO_CFLAGS) $(LIBCURL_CFLAGS) \
	-DOPENSSL_API_COMPAT=0x10100000L \
	$(WARNINGS) \
	$(NULL)
ALL_CPPFLAGS += $(INCLUDE_PARMS)
LDLIBS += $(GLIB2_LIBS) $(LIBCRYPTO_LIBS) $(LIBCURL_LIBS)


GLIB2_CFLAGS := $(shell $(PKG_CONFIG) --silence-errors --cflags glib-2.0)
GLIB2_LIBS := $(shell $(PKG_CONFIG) --silence-errors --libs glib-2.0)
LIBCRYPTO_CFLAGS := $(shell $(PKG_CONFIG) --silence-errors --cflags libcrypto)
LIBCRYPTO_LIBS := $(shell $(PKG_CONFIG) --silence-errors --libs libcrypto)
LIBCURL_CFLAGS := $(shell $(PKG_CONFIG) --silence-errors --cflags libcurl)
LIBCURL_LIBS := $(shell $(PKG_CONFIG) --silence-errors --libs libcurl)

BUILD_TARGETS := skip-$(bin_PROGRAM)
INSTALL_TARGETS := skip-$(bin_PROGRAM)
ifneq (${HAVE_OPENSSL},0)
ifneq (${HAVE_GLIB2},0)
ifneq (${HAVE_LIBCURL},0)
BUILD_TARGETS := $(bin_PROGRAM)
INSTALL_TARGETS := install-$(bin_PROGRAM)
endif
endif
endif

all: $(BUILD_TARGETS)

install: $(INSTALL_TARGETS)

$(bin_PROGRAM): $($(bin_PROGRAM)_OBJS)

skip-$(bin_PROGRAM):
	echo "  SKIP    $(bin_PROGRAM) due to unresolved dependencies"

install-$(bin_PROGRAM): $(bin_PROGRAM)
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -c $^ $(DESTDIR)$(USRBINDIR)

clean:
	$(RM) -f $($(bin_PROGRAM)_OBJS) $(bin_PROGRAM) .check-dep-$(bin_PROGRAM) .detect-openssl.dep.c

.PHONY: all install clean skip-$(bin_PROGRAM) install-$(bin_PROGRAM)

$($(bin_PROGRAM)_OBJS): .check-dep-$(bin_PROGRAM)

.detect-openssl.dep.c:
	echo "#include <openssl/evp.h>" > $@
	echo "#if OPENSSL_VERSION_NUMBER < 0x10100000L" >> $@
	echo "  #error openssl version 1.1.0 is required" >> $@
	echo "#endif" >> $@
	echo "static void __attribute__((unused)) test(void) {" >> $@
	echo "    EVP_MD_CTX *ctx = EVP_MD_CTX_new();" >> $@
	echo "    EVP_MD_CTX_free(ctx);" >> $@
	echo "}" >> $@

.check-dep-$(bin_PROGRAM): .detect-openssl.dep.c
	$(call check_dep, \
		"$(bin_PROGRAM)", \
		"glib.h", \
		"glib2-devel / libglib2.0-dev", \
		"HAVE_GLIB2=0")
	$(call check_dep, \
		"$(bin_PROGRAM)", \
		$^, \
		"openssl-devel / libssl-dev version >= 1.1.0", \
		"HAVE_OPENSSL=0", \
		"-I.")
	$(call check_dep, \
		"$(bin_PROGRAM)", \
		"curl/curl.h", \
		"libcurl-devel", \
		"HAVE_LIBCURL=0")
	touch $@

=== debian/changelog ===
s390-tools (2.31.0-0ubuntu5.3) noble; urgency=medium

  * Add missing commit/patch
    d/p/lp-2103414-cpumf-lscpumf-Add-support-for-IBM-z17-counter-sets.patch
    that caused a failed verification of 2.31.0-0ubuntu5.2 (LP: #2103414).

 -- Frank Heimes <frank.heimes@canonical.com>  Fri, 08 Aug 2025 11:32:43 +0200

s390-tools (2.31.0-0ubuntu5.2) noble; urgency=medium

  * Add d/p/lp-2103414-s390-tools-libutil-Add-machine-type-3932.patch and
    d/p/lp-2103414-libutil-Add-machine-type-definition-for-z17.patch to
    achieve support for IBM z17 (and z16 GA2) hw specific CPU-MF counters
    (LP: #2103414).
  * Add d/p/lp-2078347-udev-Introduce-rule-to-set-newly-hotplugged-CPUs.patch
    that fixes CPUs from staying offline (LP: #2078347).
  * Add d/p/lp-2044104-zdev-option-to-identify-files-created-by-zdev.patch to
    avoid rebuild initramfs by chzdev -e if zdev:early=0 set (LP: #2044104).

 -- Frank Heimes <frank.heimes@canonical.com>  Wed, 09 Jul 2025 12:46:52 +0200

s390-tools (2.31.0-0ubuntu5.1) noble-proposed; urgency=medium

  * SRU: LP: #2076340: No-change rebuild to pick up changed build flags
    on ppc64 and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 09 Aug 2024 04:33:21 +0200

s390-tools (2.31.0-0ubuntu5) noble; urgency=medium

  * Add the following commits as patches:
    - d/p/lp-2059303-rust-pv-test-Code-Certificate-refactoring.patch
      (excluded patching binary files rust/pv/tests/assets/cert/der.crl and
       rust/pv/tests/assets/cert/der.crt, which is not supported by quilt
       - these files are needed for testing only)
    - d/p/lp-2059303-rust-pv-Support-Armonk-in-IBM-signing-key-subject.patch
    - d/p/lp-2059303-genprotimg-support-Armonk-in-IBM-signing-key-subject.patch
    - d/p/lp-2059303-libpv-Support-Armonk-in-IBM-signing-key-subject.patch
    - d/p/lp-2059303-pvattest-Fix-root-ca-parsing.patch
    to fix Secure Execution tooling and accept new IBM host-key
    subject locality. LP: #2059303
  * Add d/p/lp-2058944-dbginfo.sh-dash-compatible-copy-sequence.patch
    to fix dash incompatibility in dbginfo.sh. LP: #2058944

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 02 Apr 2024 12:45:30 +0200

s390-tools (2.31.0-0ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:56:47 +1100

s390-tools (2.31.0-0ubuntu3) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:59:43 +0000

s390-tools (2.31.0-0ubuntu2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:19:50 +0000

s390-tools (2.31.0-0ubuntu1) noble; urgency=medium

  [ Frank Heimes ]
  * New upstream release, requested in LP: #2049612
    - Includes 'Secure Execution - Secure guest tool to bind and associate
      APQNs'. LP: #2003672
    - No new crates and no significant changes in size of the vendored crates
      tar ball.
    - Update XS-Vendored-Sources-Rust field in d/control.
    - Modify d/s390-tools.install to add targets for the new pvapconfig tool.
    - Rewrote and updated d/copyright according to DEP-5 aka
      debian.org/doc/packaging-manuals/copyright-format/1.0/
    - Add d/s390-tools.lintian-overrides to override a known false positive
      detection of lintian of libyaml in rust code.
    - Add d/gzip-files-without-timestamps-or-names.patch to
      avoid timestampes in gzip that will lead to lintian warning
      'package-contains-timestamped-gzip' and will harm reproducible builds.

  [ Simon Chopin ]
  * d/control: replace dh-cargo by dh-cargo-tools and explicit cargo
    dependency as we're not using the dh plugin

 -- Simon Chopin <schopin@ubuntu.com>  Mon, 26 Feb 2024 15:44:15 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = -D_GNU_SOURCE
export DEB_LDFLAGS_MAINT_APPEND=-rdynamic
export CARGO = /usr/share/cargo/bin/cargo
export CARGO_VENDOR_DIR = rust-vendor
export CARGO_HOME = $(CURDIR)/debian/cargo_home

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/rustc/architecture.mk
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE

ifeq ($(DEB_HOST_ARCH),s390x)
	options= V=1 HAVE_SNMP=1 SYSTEMDSYSTEMUNITDIR=/lib/systemd/system ZDEV_ALWAYS_UPDATE_INITRD=1 ZKEYKMSPLUGINDIR=/usr/libexec/zkey USRLIB64DIR=/usr/lib/s390x-linux-gnu
endif

# Enable signing in Launchpad only, and on s390x only
SIGN_SIPL=
ifeq ($(DEB_HOST_ARCH),s390x)
	ifneq (,$(wildcard /CurrentlyBuilding))
		SIGN_SIPL=yes
	endif
endif

VENDOR_TARBALL = s390-tools_$(DEB_VERSION_UPSTREAM).orig-$(CARGO_VENDOR_DIR).tar.xz

vendor-tarball-sanity-check:
	if [ -e ../$(VENDOR_TARBALL) ]; then echo "../$(VENDOR_TARBALL) already exists, bailing!"; exit 1; fi

vendor-deps:
	if QUILT_PATCHES=debian/patches quilt applied | grep vendor-remove-unused-deps ; then \
		echo "Detecting patch on vendor dir applied, aborting."; \
		exit 1; \
	fi
	rm -rf $(CARGO_VENDOR_DIR)
	# Deliberately don't use the wrapper, as it expects the configure step
	# to have occurred already.
	# If you have to modify the path here, don't forget to change the README.source doc
	# as well.
	cargo vendor --manifest-path rust/Cargo.toml $(CARGO_VENDOR_DIR)
	# Remove some crates that aren't useful for us and take up a lot of space
	rm -r \
		$(CARGO_VENDOR_DIR)/winapi \
		$(CARGO_VENDOR_DIR)/winapi-* \
		$(CARGO_VENDOR_DIR)/windows-* \
		$(CARGO_VENDOR_DIR)/windows_* \
		# End of list
	# Remove the C sources from the binding crates, we're using the system libs
	rm -r \
		$(CARGO_VENDOR_DIR)/libz-sys/src/zlib \
		$(CARGO_VENDOR_DIR)/libz-sys/src/zlib-ng \
		$(CARGO_VENDOR_DIR)/curl-sys/curl \
		# End of list
	# Remove unused and undesirable data files (e.g. test data for vendored crates)
	rm -r \
		$(CARGO_VENDOR_DIR)/vcpkg/test-data \
		$(CARGO_VENDOR_DIR)/*/tests \
		# End of list
	# Remove the checksum files to allow us to patch the crates to remove extraneous dependencies
	for crate in $(CARGO_VENDOR_DIR)/*; do \
		sed -i 's/^{"files":.*"package":"\([a-z0-9]\+\)"}$$/{"files":{},"package":"\1"}/' $$crate/.cargo-checksum.json; \
	done
	# Cleanup temp files
	rm -rf $(CARGO_HOME)

vendor-tarball: vendor-tarball-sanity-check vendor-deps
	tar -caf ../$(VENDOR_TARBALL) $(CARGO_VENDOR_DIR)

%:
	dh $@

override_dh_auto_configure:
	DEB_CARGO_CRATE=s390-tools_$(shell dpkg-parsechangelog --show-field Version) \
	$(CARGO) prepare-debian $(CARGO_VENDOR_DIR)
	/usr/share/cargo/bin/dh-cargo-vendored-sources
	dh_auto_configure

override_dh_install:
ifeq ($(DEB_HOST_ARCH),s390x)
	# no dracut
	rm -f debian/tmp/lib/s390-tools/zdev-root-update
	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump-initrd
	dh_install -ps390-tools-cpuplugd
	dh_install -ps390-tools-statd
	dh_install -ps390-tools-osasnmpd
	dh_install -ps390-tools-zkey
	dh_install -ps390-tools-chreipl-fcp-mpath
	dh_install -ps390-tools-data
	dh_install $(if $(SIGN_SIPL),-Xstage3.bin) -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd -X60-readahead.rules -Xzkey -Xchreipl-fcp-mpath -Xdata -Xstage3a.bin -Xstage3b_reloc.bin
	$(if $(SIGN_SIPL),echo 'signing:Depends=s390-tools-signed (= $(DEB_VERSION))') >> debian/s390-tools.substvars
else
	dh_install -Xstage3a.bin -Xstage3b_reloc.bin
endif

override_dh_fixperms:
	dh_fixperms
ifeq ($(DEB_HOST_ARCH),s390x)
	chmod 644 debian/s390-tools-zkey/usr/libexec/zkey/zkey-ekmfweb.so
	chmod 644 debian/s390-tools-zkey/usr/libexec/zkey/zkey-kmip.so
endif

override_dh_auto_clean:
	rm -f zipl/boot/.*.d
	dh_auto_clean -- $(options)

override_dh_auto_build:
	dh_auto_build -- $(options)

override_dh_auto_install:
	HAVE_INITRAMFS=1 HAVE_DRACUT=1 dh_auto_install -- $(options)

signing=debian/s390-tools-$(DEB_VERSION)-signing/
signingv=$(signing)/$(DEB_VERSION)
signing_tar=$(DEB_SOURCE)_$(DEB_VERSION)_$(DEB_HOST_ARCH).tar.gz
override_dh_builddeb:
	dh_builddeb
ifeq ($(DEB_HOST_ARCH),s390x)
	mkdir -p $(signingv)/control
	echo 'tarball' >$(signingv)/control/options
	cp debian/tmp/lib/s390-tools/stage3.bin $(signingv)/stage3.bin.sipl
	tar -C $(signing) -czvf $(CURDIR)/../$(signing_tar) .
	dpkg-distaddfile $(signing_tar) raw-signing -
endif
override_dh_clean:
	dh_clean
	rm -rf $(CARGO_HOME)
	rm -rf $(signing)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%s390-tools-$1.tar.gz%" \
     https://github.com/ibm-s390-linux/s390-tools/tags \
     (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## s390-tools 2.33.1

=== debian/changelog ===
s390-tools (2.33.1-0ubuntu3) oracular; urgency=medium

  * Remove gcc-multilib as dependency from d/control,
    because due to the removal of 31-bit legacy support
    gcc-multilib is no longer needed and also no longer build
    for s390x, which led to a failed package rebuild. LP: #2072257

 -- Frank Heimes <frank.heimes@canonical.com>  Thu, 04 Jul 2024 18:01:05 +0200

s390-tools (2.33.1-0ubuntu2) oracular; urgency=medium

  * No-change rebuild to enable frame pointers

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 01 Jul 2024 17:47:08 +0200

s390-tools (2.33.1-0ubuntu1) oracular; urgency=medium

  * New upstream release, requested in LP: #2067355
    - Refresh d/p/rust_paths.patch to remove fuzz and to avoid build failure
    - Run d/rules vendor-tarball to create new 'rust-vendor' folder
    - Adjust d/p/vendor-remove-unused-deps.patch due to new rust-vendor folder
    - Remove the following patches, since they're incl. in the new version:
      - d/p/lp-2058944-dbginfo.sh-dash-compatible-copy-sequence.patch
      - d/p/lp-2059303-rust-pv-test-Code-Certificate-refactoring.patch
      - d/p/lp-2059303-rust-pv-Support-Armonk-in-IBM-signing-key-subject.patch
      - d/p/lp-2059303-genprotimg-support-Armonk-in-IBM-signing-key-....patch
      - d/p/lp-2059303-libpv-Support-Armonk-in-IBM-signing-key-subject.patch
      - d/p/lp-2059303-pvattest-Fix-root-ca-parsing.patch
    - Update XS-Vendored-Sources-Rust field in d/control.
    - Adjust d/s390-tools.install* to cope with changed folders
      and to move doc files (readmes) from usr/share/s390-tools/* to
      usr/share/doc/s390-tools/* to solve lintian msgs.
    - Replace obsolete Build-Depends pkg-config pkgconf to solve lintian msg.
    - Redefine Section in d/control for libraries to solve lintian msgs.
    - Update DEP-3 header (fix typo and expand description) of
      d/p/debian/patches/gzip-files-without-timestamps-or-names.patch.
    - Add Build-Depends-Package line to *.symbol files to solve lintian msgs.
    - Remove all references in d/control to 31-bit 's390',
      since 31-bit legacy support (s390) got fully dropped.
    - Add d/s390-tools-zkey.lintian-overrides to silence false positive
      lintian warning 'package-has-unnecessary-activation-of-ldconfig-trigger'.
    - Adjust d/s390-tools.docs to rename the upstream changelog and
      solve lintian msg.
    - Add d/com.github.s390-tools.z90crypt.metainfo.xml and
      add it to d/s390-tools.install.s390x to solve lintian warning
      'appstream-metadata-missing-modalias-provide
      lib/udev/rules.d/40-z90crypt.rules'.

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 28 May 2024 10:32:08 +0200

## s390-tools 2.34.0

=== rust/Makefile ===
include ../common.mak
HAVE_CARGO ?= 1
HAVE_OPENSSL ?= 1
HAVE_LIBCURL ?= 1

INSTALL_TARGETS := skip-build
BUILD_TARGETS := skip-build
PV_BUILD_TARGETS := skip-pv-build
CARGO_TARGETS :=
PV_TARGETS :=
CARGO_TEST_TARGETS :=

ifneq (${HAVE_CARGO},0)
	CARGO_TARGETS :=

	BUILD_TARGETS = $(CARGO_TARGETS)
	INSTALL_TARGETS := install-rust-tools install-man
	CARGO_TEST_TARGETS = $(addsuffix .test, $(CARGO_TARGETS))

ifneq (${HAVE_OPENSSL},0)
ifneq (${HAVE_LIBCURL},0)
	PV_TARGETS := pvsecret pvapconfig pvattest

	PV_BUILD_TARGETS := $(PV_TARGETS)
	CARGO_TEST_TARGETS += $(addsuffix .test,pv $(PV_TARGETS))
endif #LIBCURL
endif #OPENSSL
	TEST_TARGETS := $(addsuffix _build,$(CARGO_TEST_TARGETS))
endif #CARGO

BUILD_TARGETS += $(PV_BUILD_TARGETS)

# build release targets by default
ifeq ("${D}","0")
	ALL_CARGOFLAGS += --release
endif

# the cc crate uses these variables to compile c code. It does not open a shell
# to call the compiler, so no echo etc. allowed here, just a path to a program
$(BUILD_TARGETS) $(TEST_TARGETS) rust-test: CC = $(CC_SILENT)
$(BUILD_TARGETS) $(TEST_TARGETS) rust-test: AR = $(AR_SILENT)

$(PV_TARGETS): .check-dep-pvtools
$(PV_TARGETS) $(CARGO_TARGETS): .check-cargo .no-cross-compile
	$(CARGO_BUILD) --bin $@ $(ALL_CARGOFLAGS)
.PHONY: $(PV_TARGETS) $(CARGO_TARGETS)

$(TEST_TARGETS): ALL_CARGOFLAGS += --no-run
$(CARGO_TEST_TARGETS) $(TEST_TARGETS): .check-cargo .no-cross-compile
	$(CARGO_TEST) --package $(basename $@) --all-features $(ALL_CARGOFLAGS)
.PHONY: $(TEST_TARGETS) $(CARGO_TEST_TARGETS)

skip-build:
	echo "  SKIP    rust-tools due to unresolved dependencies"

skip-pv-build:
	echo "  SKIP    rust-pv-tools due to unresolved dependencies"

all: $(BUILD_TARGETS)
install: $(INSTALL_TARGETS)
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 pvattest/tools/pvextract-hdr "$(DESTDIR)$(USRBINDIR)"

print-rust-targets:
	echo $(BUILD_TARGETS)

clean:
	$(CARGO_CLEAN) ${ALL_CARGOFLAGS}
	$(RM) -- .check-dep-pvtools .detect-openssl.dep.c .check-cargo

rust-test: $(CARGO_TEST_TARGETS)

install-rust-tools: $(BUILD_TARGETS)
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
	$(foreach target,$(CARGO_TARGETS),\
		$(INSTALL) target/release/$(target) $(DESTDIR)$(USRBINDIR);)
	$(foreach target,$(PV_TARGETS),\
		$(INSTALL) target/release/$(target) $(DESTDIR)$(USRBINDIR);)

install-man:
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1
	$(foreach target,$(CARGO_TARGETS),\
		$(INSTALL) -m 644 $(target)/man/*.1 -t $(DESTDIR)$(MANDIR)/man1;)
	$(foreach target,$(PV_TARGETS),\
		$(INSTALL) -m 644 $(target)/man/*.1 -t $(DESTDIR)$(MANDIR)/man1;)

.PHONY: all install clean skip-build install-rust-tools print-rust-targets install-man rust-test

.check-cargo:
ifeq ($(shell command -v $(CARGO)),)
	$(call check_dep, \
		"rust/cargo", \
		"invalid-incl", \
		"cargo", \
		"HAVE_CARGO=0")
endif
	touch $@

.no-cross-compile:
ifneq ($(HOST_ARCH), $(BUILD_ARCH))
	$(error Cross compiling is not supported for rust code. Specify HAVE_CARGO=0 to disable rust compilation)
endif
.PHONY: .no-cross-compile

.detect-openssl.dep.c:
	echo "#include <openssl/evp.h>" > $@
	echo "#if OPENSSL_VERSION_NUMBER < 0x10101000L" >> $@
	echo "  #error openssl version 1.1.1 is required" >> $@
	echo "#endif" >> $@
	echo "static void __attribute__((unused)) test(void) {" >> $@
	echo "    EVP_MD_CTX *ctx = EVP_MD_CTX_new();" >> $@
	echo "    EVP_MD_CTX_free(ctx);" >> $@
	echo "}" >> $@

.check-dep-pvtools: .detect-openssl.dep.c
	$(call check_dep, \
		"Rust-pv", \
		$^, \
		"openssl-devel / libssl-dev version >= 1.1.1", \
		"HAVE_OPENSSL=0", \
		"-I.")
	$(call check_dep, \
		"Rust-pv", \
		"curl/curl.h", \
		"libcurl-devel", \
		"HAVE_LIBCURL=0")
	touch $@

=== debian/changelog ===
s390-tools (2.34.0-0ubuntu2) oracular; urgency=medium

  * The following solves (LP: #2077055):
    - Add d/p/discard-note-package-in-lds-files-to-solve-linker-error.patch
      to fix a linker issue that started to happen on oracular builds.
    - Add d/p/fix-unnecessary-qualification-error-in-ffi-rs-.patch
      to solve a Rust compile error.

 -- Frank Heimes <frank.heimes@canonical.com>  Mon, 19 Aug 2024 14:25:44 +0200

s390-tools (2.34.0-0ubuntu1) oracular; urgency=medium

  * New upstream release. (LP: #2073786)
    - Remove d/p/gzip-files-without-timestamps-or-names.patch and
    - d/p/lp-2072366-Revert-zipl-src-Fix-problems-when-target-params.patch
      since the patches are included in the new upstream release.

 -- Frank Heimes <frank.heimes@canonical.com>  Thu, 01 Aug 2024 17:01:56 +0200

s390-tools (2.33.1-0ubuntu4) oracular; urgency=medium

  * Add d/p/lp-2072366-Revert-zipl-src-Fix-problems-when-target-params.patch
    to fix an issue with zipl target parameters that is causing build failures
    on Cloudware oracular s390x. (LP: #2072366)

 -- Frank Heimes <frank.heimes@canonical.com>  Mon, 08 Jul 2024 07:57:31 +0200

=== debian/control ===
Source: s390-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>
Build-Depends:
 bsdextrautils,
 cargo,
 debhelper-compat (= 13),
 dh-cargo-tools,
 dh-exec,
 libcryptsetup-dev,
 libcurl4-openssl-dev,
 libfuse3-dev,
 libglib2.0-dev,
 libjson-c-dev,
 liblockfile-dev,
 libncurses-dev,
 libpfm4-dev,
 libsnmp-dev,
 libssl-dev,
 libxml2-dev,
 libz-dev,
 pkgconf,
 quilt
Standards-Version: 4.6.2
Homepage: https://github.com/ibm-s390-linux/s390-tools
XS-Build-Indep-Architecture: s390x
XS-Vendored-Sources-Rust: aho-corasick@1.1.2, anstream@0.3.2, anstyle-parse@0.2.0, anstyle-query@1.0.0, anstyle-wincon@1.0.1, anstyle@1.0.0, anyhow@1.0.71, autocfg@1.1.0, bitflags@1.3.2, bitflags@2.4.1, byteorder@1.4.3, cc@1.0.79, cfg-if@1.0.0, clap@4.3.4, clap_builder@4.3.4, clap_complete@4.3.1, clap_derive@4.3.2, clap_lex@0.5.0, colorchoice@1.0.0, curl-sys@0.4.72+curl-8.6.0, curl@0.4.44, errno-dragonfly@0.1.2, errno@0.3.1, foreign-types-shared@0.1.1, foreign-types@0.3.2, getrandom@0.2.10, hashbrown@0.12.3, heck@0.4.1, hermit-abi@0.3.1, indexmap@1.9.3, io-lifetimes@1.0.11, is-terminal@0.4.7, itoa@1.0.6, lazy_static@1.4.0, libc@0.2.146, libz-sys@1.1.9, linux-raw-sys@0.3.8, log@0.4.19, memchr@2.6.4, once_cell@1.19.0, openssl-macros@0.1.1, openssl-probe@0.1.5, openssl-sys@0.9.96, openssl@0.10.60, pkg-config@0.3.27, ppv-lite86@0.2.17, proc-macro2@1.0.75, quote@1.0.35, rand@0.8.5, rand_chacha@0.3.1, rand_core@0.6.4, regex-automata@0.4.3, regex-syntax@0.8.2, regex@1.10.2, rustix@0.37.27, ryu@1.0.13, schannel@0.1.21, serde@1.0.164, serde_derive@1.0.164, serde_test@1.0.176, serde_yaml@0.9.21, socket2@0.4.9, strsim@0.10.0, syn@2.0.47, terminal_size@0.2.6, thiserror-impl@1.0.40, thiserror@1.0.40, unicode-ident@1.0.9, unsafe-libyaml@0.2.8, utf8parse@0.2.1, vcpkg@0.2.15, wasi@0.11.0+wasi-snapshot-preview1, zerocopy-derive@0.7.32, zerocopy@0.7.32

Package: s390-tools
Architecture: s390x amd64 ppc64el arm64
Priority: important
Depends:
 gawk [s390x],
 s390-tools-data,
 udev [s390x],
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
 ${signing:Depends}
Recommends: sg3-utils [s390x]
Suggests:
 blktrace [s390x],
 lsscsi [s390x],
 mdevctl [s390x],
 multipath-tools [s390x],
 rsync [s390x],
 s390-tools-chreipl-fcp-mpath [s390x],
 s390-tools-cpuplugd [s390x],
 s390-tools-osasnmpd [s390x],
 s390-tools-statd [s390x]
Description: fundamental utilities for Linux on z Systems
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.
  * hsavmcore, which is used to make the dump process with kdump more
    efficient.
  * lshwc, which is used to extract and list complete counter sets

Package: s390-tools-cpuplugd
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: cpuplugd utility for Linux on z Systems
 The package contains cpuplugd hotplug daemon from the s390-tools
 collection of utilities.

Package: s390-tools-statd
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: s390-tools (<<1.34.0-0ubuntu7~)
Replaces: s390-tools (<<1.34.0-0ubuntu7~)
Description: mon_statd monitoring daemons for Linux on z Systems
 The package contains mon_procd and mon_fsstatd z/VM monitoring
 daemons for Linux on z Systems from the s390-tools collection of
 utilities. These tools are also known as mon_statd.

Package: s390-tools-osasnmpd
Architecture: s390x
Depends: udev, ${misc:Depends}, ${shlibs:Depends}
Description: osasnmpd utility for Linux on z Systems
 The package contains osasnmpd monitoring daemon from the s390-tools
 collection of utilities.

Package: s390-tools-zkey
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zkey utilities for Linux on z Systems
 The package contains zkey and zkey-cryptsetup from the s390-tools
 collection of utilities.

Package: libekmfweb1
Section: libs
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: integration with IBM Enterprise Key Management Foundation
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the runtime library.

Package: libekmfweb-dev
Section: libdevel
Architecture: s390x
Depends: ${misc:Depends}
Description: integration with IBM Enterprise Key Management Foundation (development)
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the development library and headers.

Package: libkmipclient1
Section: libs
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: KMIP client library
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the runtime library.

Package: libkmipclient-dev
Section: libdevel
Architecture: s390x
Depends: ${misc:Depends}
Description: KMIP client library (development)
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the development library and headers

Package: s390-tools-chreipl-fcp-mpath
Architecture: s390x
Depends: multipath-tools, multipath-tools-boot, udev, ${misc:Depends}
Description: chreipl-fcp-mpath utility for Linux on z Systems
 The package contains chreipl-fcp-mpath toolset from the s390-tools collection
 of utilities, that uses multipath information to change the configured FCP
 re-IPL path on detecting issues with the current path.

Package: s390-tools-data
Architecture: all
Depends: ${misc:Depends}
Replaces: s390-tools (<< 2.28.0-0ubuntu2)
Breaks: s390-tools (<< 2.28.0-0ubuntu2)
Description: fundamental utilities for Linux on z Systems (data files)
 Host architecture independent files used by s390-tools utilities for
 z Systems. Currently this package ships stage3a/b files for genprotimg.

=== debian/rules ===
--- 
+++ 
@@ -94,6 +94,10 @@
 	dh_install -Xstage3a.bin -Xstage3b_reloc.bin
 endif
 
+override_dh_installdocs:
+	mv CHANGELOG.md changelog
+	dh_installdocs
+
 override_dh_fixperms:
 	dh_fixperms
 ifeq ($(DEB_HOST_ARCH),s390x)
